
// export default defineComponent(({ name, schema, template }) => {
//     name(`exnihilo:barrel`);
//     schema({
//         description: `Make this block instance of a ex nihilo "barrel" block`,
//         type: `object`,
//         anyOf: [
//             { required: [`texture`, `fluid`, `solid`, `compost`] }
//         ],
//         properties: {
//             texture: {
//                 description: `Set the textures for every types of block property`,
//                 type: `object`,
//                 anyOf: [
//                     { required: [`side`, `top`, `bottom`] }
//                 ],
//                 properties: {
//                     side: {
//                         description: `Side texture`,
//                         type: `string`
//                     },
//                     top: {
//                         description: `Top texture`,
//                         type: `string`
//                     },
//                     bottom: {
//                         description: `Bottom texture`,
//                         type: `string`
//                     }
//                 }
//             },
//             fluid: {
//                 description: `Desribes the difference fluid types can contain in barrel`,
//                 type: `array`
//             },
//             solid: {
//                 description: `Desribes the difference solid block types can contain in barrel`,
//                 type: `array`
//             },
//             compost: {
//                 description: `Desribes compost texture types can contain in barrel`,
//                 type: `array`
//             }
//         }
//     });

//     const mode = {
//         fluid: 1,
//         solid: 2,
//         compost: 3
//     }

//     template(({ fluid, solid, compost, texture }, { create }) => {
//         {
//             let blockTag = `exnihilo:barrel`;
//             create({ [`tag:${blockTag}`]: {} }, `minecraft:block/components`);
//         }
//         {
//             let types = Math.max(fluid ? fluid.length : 0, solid ? solid.length : 0, compost ? compost.length : 0);
//             let propValueArray = [];
//             for (let i = 0; i <= types; i++) {
//                 propValueArray.push(i);
//             }
//             create({ [`exnihilo:type`]: propValueArray }, `minecraft:block/description/properties`);
//         }
//         {
//             let geometryName = `barrel`;
//             create(`geometry.${geometryName}`, `minecraft:block/components/minecraft:geometry`);
//         }
//         {
//             let modes = [];
//             for (let i = 0; i <= 3; i++) {
//                 modes.push(i);
//             }
//             create({ [`exnihilo:mode`]: modes }, `minecraft:block/description/properties`);
//         }
//         {
//             let stage = [];
//             for (let i = 0; i <= 7; i++) {
//                 stage.push(i);
//             }
//             create({ [`exnihilo:stage_alpha`]: stage }, `minecraft:block/description/properties`);
//             create({ [`exnihilo:stage_beta`]: stage }, `minecraft:block/description/properties`);
//         }
//         {
//             let i = 8;
//             for (let stage_b = 0; stage_b <= 7; stage_b++) {
//                 for (let stage_a = 0; stage_a <= 7; stage_a++) {
//                     create(
//                         `q.block_property('exnihilo:stage_beta') == ${stage_b} && q.block_property('exnihilo:stage_alpha') == ${stage_a}`,
//                         `minecraft:block/components/minecraft:part_visibility/conditions/${i}`
//                     );
//                     i += 16;
//                 }
//             }
//         }
//         {
//             create({
//                 "*": texture.side,
//                 up: texture.top,
//                 down: texture.bottom
//             }, `minecraft:block/components/minecraft:material_instances`)
//         }
//         {
//             create({ event: "exnihilo:idle" }, `minecraft:block/components/minecraft:on_interact`)
//             create({ "exnihilo:idle": {} }, `minecraft:block/events`)
//         }

//         if (fluid) {
//             for (let f in fluid) {
//                 create({
//                     condition: `q.block_property('exnihilo:mode') == ${mode.fluid} && q.block_property('exnihilo:type') == ${f}`
//                 }, `minecraft:block/permutations`)
//             }
//         }
//     });
// });