import { Entity, Block } from "@minecraft/server";

export class EntityBase {
    public entity: Entity;

    constructor(block: Block, entity: Entity = undefined) {
        if (!entity) this.entity = (() => {
            let entities = block.dimension.getEntitiesAtBlockLocation(block.location);
            for (let e of entities) if (e) return e;
        }).call(this);
        else this.entity = entity;
    }
}