const NAMESPACE = "exnihilo";

function prefix(s: string): string {
    return `${NAMESPACE}:${s}`;
}

/**
 * Return value if it is not null else return defaultValue or empty string
 */
function notNull(value: any, defaultValue: any = ""): any {
    return value !== null ? value : defaultValue;
}

function splitNamespace(s: string): { "isVanilla": boolean, "first": string, "last": string } {
    let l = s.split(":")
    return {
        "isVanilla": l[0] == "minecraft",
        "first": l[0],
        "last": l[1]
    };
}

export {
    notNull,
    prefix,
    splitNamespace,
};